%global debug_package %{nil}

Summary:        Header-only C++ library for efficient mathematical optimization
Name:           ensmallen
Version:        2.19.0
Release:        3%{?dist}
License:        BSD
URL:            https://www.ensmallen.org
Source0:        %{url}/files/%{name}-%{version}.tar.gz

BuildRequires:  cmake >= 2.8.5 gcc-c++
BuildRequires:  armadillo-devel >= 9.800.0
Requires:       armadillo-devel >= 9.800.0

%description
ensmallen is a high-quality C++ library for non-linear numerical optimization. It provides 
many types of optimizers that can be used for virtually any numerical optimization task. It 
also allows optional callbacks to customize the optimization process.

%package devel
Summary:  Header-only C++ library for efficient mathematical optimization
Provides: ensmallen-static = %{version}-%{release}

%description devel
ensmallen is a high-quality C++ library for non-linear numerical optimization. It provides 
many types of optimizers that can be used for virtually any numerical optimization task. It 
also allows optional callbacks to customize the optimization process.

%prep
%autosetup -p1

%build
%cmake -DENSMALLEN_CMAKE_DIR=%{_libdir}/cmake/ensmallen/ -DBUILD_TESTS=ON

%cmake_build -t ensmallen_tests

%install
%cmake_install

%check
# disable SmallLovaszThetaSdp, it causes a bug in the ensmallen dependencies.
# disable DeprecatedSmallLovaszThetaSdp, it is deprecated and can be removed in ensmallen 2.10.0.
# probabilistic tests may fail, so just make sure the test suite passes at least once in five runs.

success=0;
cd %{_vpath_builddir};
for i in `seq 1 5`; do
  code=""; # success, exit 
  ./ensmallen_tests --rng-seed=time ~SmallLovaszThetaSdp ~DeprecatedSmallLovaszThetaSdp ~BBSBBLogisticRegressionTest || code=$?
  if [ "a$code" == "a" ]; then
    success=1;
    break;
  fi
done
if [ $success -eq 0 ]; then
  false # else, build error.
fi
cd ..;

%files devel
%license LICENSE.txt
%{_includedir}/ensmallen.hpp
%{_includedir}/ensmallen_bits/
%{_libdir}/cmake/ensmallen/ensmallen-config-version.cmake
%{_libdir}/cmake/ensmallen/ensmallen-config.cmake
%{_libdir}/cmake/ensmallen/ensmallen-targets.cmake

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.19.0-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.19.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 25 2023 Wang Guodong <gordonwwang@tencent.com> - 2.19.0-1
- initial build
